%define section         free

# To make the tarball:
# mkdir ews-mapper
# svn export http://svn.apache.org/repos/asf/webservices/ews/tags/EWS_MAPPER_1_1/ ews-mapper/mapper
# svn export -r {2005-10-20} http://svn.apache.org/repos/asf/webservices/ews/trunk/project.xml ews-mapper/project.xml
# svn export -r {2005-10-20} http://svn.apache.org/repos/asf/webservices/ews/trunk/project.properties ews-mapper/project.properties

Name:		ews-mapper
Summary:	EWS Mapper is used to generate JAXRPC artifacts from WSDL and JAXRPC Mapping file
Version: 	1.1
Release:	1jpp_1rh
Epoch:		0

URL: 		http://svn.apache.org/repos/asf/webservices/ews/trunk/mapper/
License: 	Apache Public License v2.0
Group: 		Development/Libraries/Java
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0: 	%{name}-%{version}.tgz
Source1:    pom-maven2jpp-depcat.xsl
Source2:    pom-maven2jpp-newdepmap.xsl
Source3:    pom-maven2jpp-mapdeps.xsl
Source4:    %{name}-%{version}-jpp-depmap.xml

BuildRequires:	junit >= 3.8
BuildRequires:	maven >= 1.0.2
BuildRequires:	maven-plugins-base >= 1.0.2
BuildRequires:	maven-plugin-license >= 1.0.2
BuildRequires:	maven-plugin-test >= 1.0.2
BuildRequires:	maven-plugin-xdoc >= 1.0.2
BuildRequires:	axis >= 1.2.1
BuildRequires:	jakarta-commons-discovery >= 0.2
BuildRequires:  saxon-scripts >= 0:6.5.3
BuildRequires:	xmlbeans >= 1.0.4
BuildRequires:	wsdl4j >= 1.5.1
Requires:		axis >= 1.2.1
Requires:		jakarta-commons-discovery >= 0.2
Requires:		wsdl4j >= 1.5.1
Requires:		xmlbeans >= 1.0.4

BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:		noarch

%description 
The Mapper is an extension of the Axis file generation framework.
It is based on the Emitter and GeneratorFactory, it provides a JaxRpcMapper 
interface (implemented with XMLBeans) that is used to read metadata from the 
JAXRPC Mapping File. The data read from that mapping file will be used to 
generate adequate Java classes (class names, methods names and signature, ...)
and correct WSDD.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}

%build

export DEPCAT=$(pwd)/ws-scout-1.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > ws-scout-1.0-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done
for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

# All of the building takes place in mapper/
pushd mapper >& /dev/null

export MAVEN_HOME_LOCAL=$(pwd)/.maven
maven \
      -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository jar:jar javadoc:generate

# pop out of mapper/
popd >& /dev/null

%install
rm -rf $RPM_BUILD_ROOT

# main package
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 mapper/target/ews-mapper-1.1.jar \
    $RPM_BUILD_ROOT%{_javadir}/ews-mapper-%{version}.jar
ln -s ews-mapper-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/ews-mapper.jar

# javadoc
install -d -m 755 $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}
cp -pr mapper/target/docs/apidocs/* \
    $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT/%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/ews-mapper-%{version}.jar
%{_javadir}/ews-mapper.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Fri Oct 21 2005 Fernando Nasser <fnasser@redhat.com> 0:1.1-1jpp_1rh
- First Red Hat build

* Fri Oct 21 2005 Deepak Bhole <dbhole@redhat.com> 0:1.1-1jpp
- Initial build.
